//////////////////////////////////////////////////////////////////////////////
//
// "Embedded C Programming: Techniques and Applications of C and PIC MCUs"
// by Mark Siegusmund
//
// Exercise 8-1 #2
//
// User enters a series of numbers between 1-100, entry stops when a 0 is
// entered. The program then outputs the number of times each number has been
// entered, skiping numbers that had no enteries.
//
//////////////////////////////////////////////////////////////////////////////

#include <e3.h>

#define SIZE 101

void main(void)
{   
   int array[SIZE];
   
   int i, num;
   
   for(i=0; i<SIZE; i++)
      array[i] = 0;
   
   printf("\r\nEnter Numbers\r\n");
   
   for(;;)
   {
      num = get_int_usb();
      
      // Is it 0?
      if(!num)
         break;
         
      // Add to array
      array[num]++;
      printf(" ");
   }
   
   printf("\r\n");
   
   for(i=0; i<SIZE; i++)
   {
      // Index has some number in there
      if(array[i])
         printf("%u => %u, ", i, array[i]);
   }
   
   for(;;);
}
