//////////////////////////////////////////////////////////////////////////////
//
// "Embedded C Programming: Techniques and Applications of C and PIC MCUs"
// by Mark Siegusmund
//
// Exercise 8-1 #4
//
// Outputs the number of words in a string entered by the user with up to 
// 100 characters. Allows for any number of spaces between words and for
// spaces to appear before the first and after the last words.
//
//////////////////////////////////////////////////////////////////////////////

#include <e3.h>
#include <stdlib.h>
#include <input.c>
#define SIZE 100

int words(char string[]);

void main(void){   
   char line[SIZE];
   printf ( "Ready for string\r\n\r\n" ) ;
   get_string_usb ( line, SIZE );
   
   printf ( "\r\n\r\nThere were %u words in that string.", words ( line ) );
   
   for(;;);
}

int words(char data[]){
   int result = 0, i = 0;
   int first = FALSE;
   
   if ( data[0] != 0 ) {
      result = 1;
      
      while ( data[i] !=  0 ) {
         if ( data[i] != ' ' && data[i - 1] == ' ' &&  first )
            result++;

         else if ( ( data[i] != ' ' && data[i - 1] == ' ' && ! first ) || (data[i] != ' ' &&  !first ) )
            first = TRUE;
         
         i++;
      }
   }

   return ( result );
}

