//////////////////////////////////////////////////////////////////////////////
//
// "Embedded C Programming: Techniques and Applications of C and PIC MCUs"
// by Mark Siegusmund
//
// Exercise 8-1 #5
//
// Allows for continuous entry of numbers (single bytes), and outputs the
// average of last five entries.
//
//////////////////////////////////////////////////////////////////////////////

#include <e3.h>

#define SIZE 5

void main(void){
   int8 filter[SIZE], i, j;
   int16 sum;
   
   memset(&filter[0], 0, sizeof(filter));
      
   printf("Ready to filter\n\r");
   
   while(TRUE)
   {
      filter[i++] = get_int_usb();
      
      if (i >= SIZE) i = 0;
      
      sum = 0;
      
      for(j=0; j<SIZE; j++)
         sum += filter[j];
         
      printf("\r\nRunning Average = %lu\r\n\r\n", sum/SIZE);
   }
   
   for(;;);
}

