//////////////////////////////////////////////////////////////////////////////
//
// "Embedded C Programming: Techniques and Applications of C and PIC MCUs"
// by Mark Siegusmund
//
// Exercise 8-1 #3
//
// Outputs the number of words in a string entered by the user with up to 
// 100 characters.
//
//////////////////////////////////////////////////////////////////////////////

#include <e3.h>

#define SIZE 100

int words(char string[]);

void main(void)
{
   char line[SIZE];

   printf("Ready for string\r\n\r\n");

   get_string_usb(line, SIZE);
   
   printf("\r\n\r\nThere were %u words in that string.", words(line));
   
   for(;;);
}

int words(char data[])
{
   int result=0, i=0;
   while(data[i]!=0)
      if(data[i++]== ' ')
         result++;
   if(data[0]!=0)
      result++;
   return(result);
}
